zoukankan      html  css  js  c++  java
  • Saruman's Army(贪心)

    Saruman the White must lead his army along a straight path from Isengard to Helm’s Deep. To keep track of his forces, Saruman distributes seeing stones, known as palantirs, among the troops. Each palantir has a maximum effective range of R units, and must be carried by some troop in the army (i.e., palantirs are not allowed to “free float” in mid-air). Help Saruman take control of Middle Earth by determining the minimum number of palantirs needed for Saruman to ensure that each of his minions is within R units of some palantir.

    Input

    The input test file will contain multiple cases. Each test case begins with a single line containing an integer R, the maximum effective range of all palantirs (where 0 ≤ R ≤ 1000), and an integer n, the number of troops in Saruman’s army (where 1 ≤n ≤ 1000). The next line contains n integers, indicating the positions x1, …, xnof each troop (where 0 ≤ xi ≤ 1000). The end-of-file is marked by a test case withR = n = −1.

    Output

    For each test case, print a single integer indicating the minimum number of palantirs needed.

    Sample Input

    0 3
    10 20 20
    10 7
    70 30 1 7 15 20 50
    -1 -1

    Sample Output

    2
    4

    Hint

    In the first test case, Saruman may place a palantir at positions 10 and 20. Here, note that a single palantir with range 0 can cover both of the troops at position 20.

    In the second test case, Saruman can place palantirs at position 7 (covering troops at 1, 7, and 15), position 20 (covering positions 20 and 30), position 50, and position 70. Here, note that palantirs must be distributed among troops and are not allowed to “free float.” Thus, Saruman cannot place a palantir at position 60 to cover the troops at positions 50 and 70.

    题目意思:Saruman的军队有n个人,为了控制住他的军队,他将一个装着放在所给样例数的一些士兵身上,给出装置的控制范围r,要求出最少需要多少个装置就能完全控制住他的军队。

    解题思路:这是一道贪心题,贪心策略是从第一个士兵开始向后面遍历,找到满足距离小于r的最右边的点,这一个点一定会作为一个装着的放置的位置,然后从这个位置开始找到右边的最小的不能被覆盖到的位置作为下一次的起点....循环下去,直到所有的点都被覆盖到。

    上代码:

     1 #include<stdio.h>
     2 #include<algorithm>
     3 using namespace std;
     4 int main()
     5 {
     6     int n,r,count,i,k,p;
     7     int a[1010];
     8     while(scanf("%d%d",&r,&n)!=EOF)
     9     {
    10         if(r==-1&&n==-1)
    11         {
    12             break;
    13         }
    14         for(i=0; i<n; i++)
    15         {
    16             scanf("%d",&a[i]);
    17         }
    18         sort(a,a+n);
    19         i=0;
    20         count=0;
    21         while(i<n)
    22         {
    23             k=a[i]+r;
    24             while(i<n&&a[i]<=k)///找到满足距离小于r的最右边的点
    25             {
    26                 i++;
    27             }
    28             p=a[i-1]+r;///确定的人
    29             while(i<n&&a[i]<=p)
    30             {
    31                 i++;
    32             }
    33             count++;
    34         }
    35         printf("%d
    ",count);
    36     }
    37     return 0;
    38 }
  • 相关阅读:
    POJ 2991 Crane(线段树)
    HDU 1496 Equations(哈希表)
    POJ 2785 4 Values whose Sum is 0(哈希表)
    挑战程序设计竞赛 3.2 常用技巧精选(一)
    AOJ 0531:Paint Color(二维离散+imos)
    POJ 2549:Subsets(哈希表)
    POJ 3977:Subset(折半枚举+二分)
    CodeForces 148D Bag of mice
    POJ 2151 Check the difficulty of problems
    HDU 3853 LOOPS
  • 原文地址:https://www.cnblogs.com/wkfvawl/p/8933584.html
Copyright © 2011-2022 走看看